#property copyright "Loknar"
#property link      "loknar at list dot ru"
extern int MaxBars=50000;
extern int UseBars=4;
extern int MinPoints=100;
extern int MaxIndicators=10;
extern int SavePatternLimit=2;
int TakeProfitMin = 60;
int TakeProfitMax = 200;
int StopLossMin = 30;
int StopLossMax = 60;
int PFCount = 50;
extern bool print_data=true;
extern bool debug=true;
bool born;
int PatternDown[1], PatternUp[1];
int tech1, tech2, popcounter=0;
double IndArray[200000][20][5];
double AO[2], AD[4], ADXDIplus[2], ADXDIminus[2], ADX[2], ATR[4], Bears[2], Bulls[2], CCI[2], DEM[2], Force[2], MACDM[2], MACDS[2], BWMFI[4], Momentum[2], MFI[2], MA1[2], MA2[2], OBV[4], SAR[4], RSI[2], STD[4], StochM[2], StochS[2], Vol[4];
int AmountOfSystems, StopLoss[], TakeProfit[];
double dAsk, dBid;
int SLSize, TPSize;
bool loader;
int VirtOrderType[], VirtTicket[], VirtClosedOrdersCount[], ticker, range;
double VirtOpenPrice[], VirtClosePrice[], VirtOrderProfit[], VirtStopLoss[], VirtTakeProfit[], PFout, VirtClosedOrders[2000][8][60];

int init() {
   if (print_data) Print("Initialization started. Searching patterns...");
   SearchPatterns();
   tech1=ArraySize(PatternDown);
   tech2=ArraySize(PatternUp);
   if (print_data) Print("Patterns DOWN : ",tech1," , Patterns UP : ",tech2);
}
int deinit() {
   Comment("");
}

void SearchPatterns() {
   double a;
   int b=0, c=0;
   for (int pc=MaxBars-1;pc>UseBars;pc--) {
      a=iClose(Symbol(),0,pc)-iClose(Symbol(),0,pc-UseBars);
      if (a>MinPoints*Point) {if (ArrayRange(PatternDown,0)<b+1) ArrayResize(PatternDown, b+1); PatternDown[b]=pc; b++; pc=pc-UseBars;}
      if (a<-MinPoints*Point) {if (ArrayRange(PatternUp,0)<c+1) ArrayResize(PatternUp, c+1); PatternUp[c]=pc; c++; pc=pc-UseBars;}
   }
}
void OptInit() {
   AmountOfSystems = ((TakeProfitMax-TakeProfitMin)/10+1) * ((StopLossMax-StopLossMin)/10+1);
   range=ArrayRange(VirtClosedOrders,2);
   if (AmountOfSystems!=range) {Print("ERROR : Array with systems not sized correctly! Amount of systems : ",AmountOfSystems); return(0);}
   Print("Normalization finished. Total amount of systems counted : "+AmountOfSystems+" . Completing initialization...");
   Comment("Normalization finished. Total amount of systems counted : "+AmountOfSystems+" . Completing initialization...");
   ArrayResize(VirtOrderType, range);
   ArrayResize(VirtTicket, range);
   ArrayResize(VirtOpenPrice, range);
   ArrayResize(VirtClosePrice, range);
   ArrayResize(VirtOrderProfit, range);
   ArrayResize(VirtStopLoss, range);
   ArrayResize(VirtTakeProfit, range);
   ArrayResize(VirtClosedOrdersCount, range);
   ArrayInitialize(VirtClosedOrdersCount, 0);
   ArrayResize(StopLoss, AmountOfSystems);
   ArrayResize(TakeProfit, AmountOfSystems);
   ArrayInitialize(VirtOrderType, 0);
   ArrayInitialize(VirtTicket, 0);
   ArrayInitialize(VirtOpenPrice, 0.0);
   ArrayInitialize(VirtClosePrice, 0.0);
   ArrayInitialize(VirtOrderProfit, 0.0);
   ArrayInitialize(VirtStopLoss, 0.0);
   ArrayInitialize(VirtTakeProfit, 0.0);
   ArrayInitialize(VirtClosedOrdersCount, 0);
   ArrayInitialize(StopLoss, 0.0);
   ArrayInitialize(TakeProfit, 0.0);
   SLSize=(StopLossMax-StopLossMin)/10+1;
   TPSize=(TakeProfitMax-TakeProfitMin)/10+1;
         for (int k3=0;k3<SLSize;k3++) {
            for (int k4=0;k4<TPSize;k4++) {
               TakeProfit[k3*TPSize+k4]=TakeProfitMin+10*k4;
               StopLoss[k3*TPSize+k4]=StopLossMin+10*k3;
            }
         }
   Comment("Initialiazation Completed");
   Print("Initialiazation Completed");
}

void CreatePopulation() {
   popcounter++;
   int a, a1, checker=0, ccounter, indcounter, arcounter, aar[20];
   double b;
   double range0=ArrayRange(IndArray,0);
   if (popcounter>1 && IndArray[popcounter-1][0][0]==1 && range0<popcounter) ArrayResize(IndArray, range0+1);
   IndArray[popcounter-1][0][0]=1;
   while (checker==0) {
   MathSrand(TimeLocal());
   indcounter=0;
   for (int cpc=0;cpc<20;cpc++) {
         arcounter=0;
      while (arcounter<20) {
         a1=MathRand()%20;
         for (int arc=0;arc<20;arc++) if (aar[arc]!=a1) arcounter++;
         if (arcounter==20) aar[cpc]=a1;
      }
      a=MathRand()%2;
      if (a==1) indcounter++;
      IndArray[popcounter-1][a1][1]=a;
      if (indcounter==MaxIndicators) break;
   }
   if (print_data) for (int print1=0;print1<20;print1++) if (IndArray[popcounter-1][print1][1]==1) Print("Ind taken :",print1);
   if (IndArray[popcounter-1][2][1]==1) {//ADX
      a=MathRand()%12;
      for (int aa1=0;aa1<a;aa1++) {
         if (aa1==0) {IndArray[popcounter-1][2][2]=3; continue;}
         IndArray[popcounter-1][2][2]=MathRound(IndArray[popcounter-1][2][2]*1.6180338134);//Period
      }
   }
   if (IndArray[popcounter-1][3][1]==1) {//ATR
      a=MathRand()%12;
      for (int aa2=0;aa2<a;aa2++) {
         if (aa2==0) {IndArray[popcounter-1][3][2]=3; continue;}
         IndArray[popcounter-1][3][2]=MathRound(IndArray[popcounter-1][3][2]*1.6180338134);//Period
      }
   }
   if (IndArray[popcounter-1][4][1]==1) {//Bears
      a=MathRand()%12;
      for (int aa3=0;aa3<a;aa3++) {
         if (aa3==0) {IndArray[popcounter-1][4][2]=3; continue;}
         IndArray[popcounter-1][4][2]=MathRound(IndArray[popcounter-1][4][2]*1.6180338134);//Period
      }
   }
   if (IndArray[popcounter-1][5][1]==1) {//Bulls
      a=MathRand()%12;
      for (int aa4=0;aa4<a;aa4++) {
         if (aa4==0) {IndArray[popcounter-1][5][2]=3; continue;}
         IndArray[popcounter-1][5][2]=MathRound(IndArray[popcounter-1][5][2]*1.6180338134);//Period
      }
   }
   if (IndArray[popcounter-1][6][1]==1) {//CCI
      a=MathRand()%12;
      for (int aa5=0;aa5<a;aa5++) {
         if (aa5==0) {IndArray[popcounter-1][6][2]=3; continue;}
         IndArray[popcounter-1][6][2]=MathRound(IndArray[popcounter-1][6][2]*1.6180338134);//Period
      }
   }
   if (IndArray[popcounter-1][7][1]==1) {//Demarker
      a=MathRand()%12;
      for (int aa6=0;aa6<a;aa6++) {
         if (aa6==0) {IndArray[popcounter-1][7][2]=3; continue;}
         IndArray[popcounter-1][7][2]=MathRound(IndArray[popcounter-1][7][2]*1.6180338134);//Period
      }
   }
   if (IndArray[popcounter-1][8][1]==1) {//Force
      a=MathRand()%12;
      for (int aa7=0;aa7<a;aa7++) {
         if (aa7==0) {IndArray[popcounter-1][8][2]=3; continue;}
         IndArray[popcounter-1][8][2]=MathRound(IndArray[popcounter-1][8][2]*1.6180338134);//Period
      }
   }
   if (IndArray[popcounter-1][9][1]==1) {//MACD
      a=MathRand()%12;
      for (int aa8=0;aa8<a;aa8++) {
         if (aa8==0) {IndArray[popcounter-1][9][2]=3; continue;}
         IndArray[popcounter-1][9][2]=MathRound(IndArray[popcounter-1][9][2]*1.6180338134);//FastEma
      }
      for (int aa9=0;aa9<a;aa9++) {
         if (aa9==0) {IndArray[popcounter-1][9][3]=3; continue;}
         IndArray[popcounter-1][9][3]=MathRound(IndArray[popcounter-1][9][3]*1.6180338134);//SlowEma
      }
      for (int aa10=0;aa10<a;aa10++) {
         if (aa10==0) {IndArray[popcounter-1][9][4]=3; continue;}
         IndArray[popcounter-1][9][4]=MathRound(IndArray[popcounter-1][9][4]*1.6180338134);//SignalEma
      }
   }
   if (IndArray[popcounter-1][11][1]==1) {//Momentum
      a=MathRand()%12;
      for (int aa11=0;aa11<a;aa11++) {
         if (aa11==0) {IndArray[popcounter-1][11][2]=3; continue;}
         IndArray[popcounter-1][11][2]=MathRound(IndArray[popcounter-1][11][2]*1.6180338134);//Period
      }
   }
   if (IndArray[popcounter-1][12][1]==1) {//MFI
      a=MathRand()%12;
      for (int aa12=0;aa12<a;aa12++) {
         if (aa12==0) {IndArray[popcounter-1][12][2]=3; continue;}
         IndArray[popcounter-1][12][2]=MathRound(IndArray[popcounter-1][12][2]*1.6180338134);//Period
      }
   }
   if (IndArray[popcounter-1][13][1]==1) {//MA
      a=MathRand()%12;
      for (int aa13=0;aa13<a;aa13++) {
         if (aa13==0) {IndArray[popcounter-1][13][2]=3; continue;}
         IndArray[popcounter-1][13][2]=MathRound(IndArray[popcounter-1][13][2]*1.6180338134);//Period 1
      }
      for (int aa14=0;aa14<a;aa14++) {
         if (aa14==0) {IndArray[popcounter-1][13][3]=3; continue;}
         IndArray[popcounter-1][13][3]=MathRound(IndArray[popcounter-1][13][3]*1.6180338134);//Period 2
      }
   }
   if (IndArray[popcounter-1][15][1]==1) {//SAR
      IndArray[popcounter-1][15][2]=(MathRand()%100+1)/100.0;//Step
      IndArray[popcounter-1][15][3]=(MathRand()%100+1)/100.0;//Max
   }
   if (IndArray[popcounter-1][16][1]==1) {//RSI
      a=MathRand()%8;
      for (int aa15=0;aa15<a;aa15++) {
         if (aa15==0) {IndArray[popcounter-1][16][2]=3; continue;}
         IndArray[popcounter-1][16][2]=MathRound(IndArray[popcounter-1][16][2]*1.6180338134);//Period
      }
   }
   if (IndArray[popcounter-1][17][1]==1) {//STD
      a=MathRand()%12;
      for (int aa16=0;aa16<a;aa16++) {
         if (aa16==0) {IndArray[popcounter-1][17][2]=3; continue;}
         IndArray[popcounter-1][17][2]=MathRound(IndArray[popcounter-1][17][2]*1.6180338134);//Period
      }
      for (int aa17=0;aa17<a;aa17++) {
         if (aa17==0) {IndArray[popcounter-1][17][3]=3; continue;}
         IndArray[popcounter-1][17][3]=MathRound(IndArray[popcounter-1][17][3]*1.6180338134);//Sdvig 
      }
   }
   if (IndArray[popcounter-1][18][1]==1) {//Stochastic
      a=MathRand()%12;
      for (int aa18=0;aa18<a;aa18++) {
         if (aa18==0) {IndArray[popcounter-1][18][2]=3; continue;}
         IndArray[popcounter-1][18][2]=MathRound(IndArray[popcounter-1][18][2]*1.6180338134);//K
      }
      for (int aa19=0;aa19<a;aa19++) {
         if (aa19==0) {IndArray[popcounter-1][18][3]=3; continue;}
         IndArray[popcounter-1][18][3]=MathRound(IndArray[popcounter-1][18][3]*1.6180338134);//D 
      }
      for (int aa20=0;aa20<a;aa20++) {
         if (aa20==0) {IndArray[popcounter-1][18][4]=3; continue;}
         IndArray[popcounter-1][18][4]=MathRound(IndArray[popcounter-1][18][4]*1.6180338134);//Slow 
      }
   }
      if (popcounter==1) {checker=1; break;}
      for (int cc=0;cc<popcounter-1;cc++) {
         ccounter=0;
         for (int cc1=0;cc1<20;cc1++) {
            for (int cc2=1;cc2<5;cc2++) if (IndArray[cc][cc1][cc2]==IndArray[popcounter-1][cc1][cc2]) ccounter++;
         }
         if (ccounter==80) {checker=0; break;}
         if (ccounter<80) {checker=1;}
      }
   }//checker
}


void IndValue(int shift, int mode) {
   if (IndArray[popcounter-1][0][1]==1) AO[mode]=iAO(Symbol(),0,shift); else AO[mode]=0;
   if (IndArray[popcounter-1][1][1]==1) {
      AD[mode]=iAD(Symbol(),0,shift);
      AD[mode+2]=iAD(Symbol(),0,shift+240);
   }
   else {
      AD[mode]=0;
      AD[mode+2]=0;
   }
   if (IndArray[popcounter-1][2][1]==1) ADXDIplus[mode]=iADX(Symbol(),0,IndArray[popcounter-1][2][2],PRICE_CLOSE,1,shift); else ADXDIplus[mode]=0;
   if (IndArray[popcounter-1][2][1]==1) ADXDIminus[mode]=iADX(Symbol(),0,IndArray[popcounter-1][2][2],PRICE_CLOSE,2,shift); else ADXDIminus[mode]=0;
   if (IndArray[popcounter-1][2][1]==1) ADX[mode]=iADX(Symbol(),0,IndArray[popcounter-1][2][2],PRICE_CLOSE,0,shift); else ADX[mode]=0;
   if (IndArray[popcounter-1][3][1]==1) {
      ATR[mode]=iATR(Symbol(),0,IndArray[popcounter-1][3][2],shift); 
      ATR[mode+2]=iATR(Symbol(),0,IndArray[popcounter-1][3][2],shift+24); 
   }
   else {
      ATR[mode]=0;
      ATR[mode+2]=0;
   }
   if (IndArray[popcounter-1][4][1]==1) Bears[mode]=iBearsPower(Symbol(),0,IndArray[popcounter-1][4][2],PRICE_CLOSE,shift); else Bears[mode]=0;
   if (IndArray[popcounter-1][5][1]==1) Bulls[mode]=iBullsPower(Symbol(),0,IndArray[popcounter-1][5][2],PRICE_CLOSE,shift); else Bulls[mode]=0;
   if (IndArray[popcounter-1][6][1]==1) CCI[mode]=iCCI(Symbol(),0,IndArray[popcounter-1][6][2],PRICE_CLOSE,shift); else CCI[mode]=0;
   if (IndArray[popcounter-1][7][1]==1) DEM[mode]=iDeMarker(Symbol(),0,IndArray[popcounter-1][7][2],shift); else DEM[mode]=0;
   if (IndArray[popcounter-1][8][1]==1) Force[mode]=iForce(Symbol(),0,IndArray[popcounter-1][8][2],MODE_SMA,PRICE_CLOSE,shift); else Force[mode]=0;
   if (IndArray[popcounter-1][9][1]==1) MACDM[mode]=iMACD(Symbol(),0,IndArray[popcounter-1][9][2],IndArray[popcounter-1][9][3],IndArray[popcounter-1][9][4],PRICE_CLOSE,0,shift); else MACDM[mode]=0;
   if (IndArray[popcounter-1][9][1]==1) MACDS[mode]=iMACD(Symbol(),0,IndArray[popcounter-1][9][2],IndArray[popcounter-1][9][3],IndArray[popcounter-1][9][4],PRICE_CLOSE,1,shift); else MACDS[mode]=0; 
   if (IndArray[popcounter-1][10][1]==1) {
      BWMFI[mode]=iBWMFI(Symbol(),0,shift);
      BWMFI[mode+2]=iBWMFI(Symbol(),0,shift+1);
   }
   else {
      BWMFI[mode]=0;
      BWMFI[mode+2]=0;
   }
   if (IndArray[popcounter-1][11][1]==1) Momentum[mode]=iMomentum(Symbol(),0,IndArray[popcounter-1][11][2],PRICE_CLOSE,shift); else Momentum[mode]=0;
   if (IndArray[popcounter-1][12][1]==1) MFI[mode]=iMFI(Symbol(),0,IndArray[popcounter-1][12][2],shift); else MFI[mode]=0;
   if (IndArray[popcounter-1][13][1]==1) MA1[mode]=iMA(Symbol(),0,IndArray[popcounter-1][13][2],0,MODE_SMA,PRICE_CLOSE,shift); else MA1[mode]=0;
   if (IndArray[popcounter-1][13][1]==1) MA2[mode]=iMA(Symbol(),0,IndArray[popcounter-1][13][3],0,MODE_SMA,PRICE_CLOSE,shift); else MA2[mode]=0;
   if (IndArray[popcounter-1][14][1]==1) {
      OBV[mode]=iOBV(Symbol(),0,PRICE_CLOSE,shift);
      OBV[mode+2]=iOBV(Symbol(),0,PRICE_CLOSE,shift+24);
   }
   else {
      OBV[mode]=0;
      OBV[mode+2]=0;
   }
   if (IndArray[popcounter-1][15][1]==1) {
      SAR[mode]=iSAR(Symbol(),0,IndArray[popcounter-1][15][2],IndArray[popcounter-1][15][3],shift);
      SAR[mode+2]=iClose(Symbol(),0,shift);
   }
   else {
      SAR[mode]=0;
      SAR[mode+2]=0;
   }
   if (IndArray[popcounter-1][16][1]==1) RSI[mode]=iRSI(Symbol(),0,IndArray[popcounter-1][16][2],PRICE_CLOSE,shift); else RSI[mode]=0;
   if (IndArray[popcounter-1][17][1]==1) {
      STD[mode]=iStdDev(Symbol(),0,IndArray[popcounter-1][17][2],IndArray[popcounter-1][17][3],MODE_SMA,PRICE_CLOSE,shift); 
      STD[mode+2]=iStdDev(Symbol(),0,IndArray[popcounter-1][17][2],IndArray[popcounter-1][17][3],MODE_SMA,PRICE_CLOSE,shift+24); 
   }
   else {
      STD[mode]=0;
      STD[mode+2]=0;
   }
   if (IndArray[popcounter-1][18][1]==1) StochM[mode]=iStochastic(Symbol(),0,IndArray[popcounter-1][18][2],IndArray[popcounter-1][18][3],IndArray[popcounter-1][18][4],MODE_SMA,0,0,shift); else StochM[mode]=0;
   if (IndArray[popcounter-1][18][1]==1) StochS[mode]=iStochastic(Symbol(),0,IndArray[popcounter-1][18][2],IndArray[popcounter-1][18][3],IndArray[popcounter-1][18][4],MODE_SMA,0,1,shift); else StochS[mode]=0; 
   if (IndArray[popcounter-1][19][1]==1) {
      Vol[mode]=iVolume(Symbol(),0,shift); 
      Vol[mode+2]=iVolume(Symbol(),0,shift+1); 
   }
   else {
      Vol[mode]=0;
      Vol[mode+2]=0;
   }
}

bool Signal() {
   int sig=0;
   int sigcheck;
   for (int scc=0;scc<ArrayRange(IndArray,1);scc++) sigcheck+=IndArray[popcounter-1][scc][1];
   if (IndArray[popcounter-1][0][1]==1) {
      if (AO[1]>0 && AO[0]>0) sig++;
      if (AO[1]<0 && AO[0]<0) sig++;
   }
   if (IndArray[popcounter-1][1][1]==1) {
      if (AD[0]<AD[2] && AD[1]<AD[3]) sig++;
      if (AD[0]>AD[2] && AD[1]>AD[3]) sig++;
   }
   if (IndArray[popcounter-1][2][1]==1) {
      if (ADXDIplus[0]>ADXDIminus[0] && ADXDIplus[1]>ADXDIminus[1] && ADX[0]>ADXDIminus[0] && ADX[1]>ADXDIminus[1]) sig++;
      if (ADXDIplus[0]<ADXDIminus[0] && ADXDIplus[1]<ADXDIminus[1] && ADX[0]>ADXDIplus[0] && ADX[1]>ADXDIplus[1]) sig++;
      if (ADXDIplus[0]>ADXDIminus[0] && ADXDIplus[1]>ADXDIminus[1] && ADX[0]<ADXDIplus[0] && ADX[1]<ADXDIplus[1]) sig++;
      if (ADXDIplus[0]<ADXDIminus[0] && ADXDIplus[1]<ADXDIminus[1] && ADX[0]<ADXDIminus[0] && ADX[1]<ADXDIminus[1]) sig++;
   }   
   if (IndArray[popcounter-1][3][1]==1) {
      if (ATR[0]>ATR[2] && ATR[1]>ATR[3]) sig++;
      if (ATR[0]<ATR[2] && ATR[1]<ATR[3]) sig++;
   }
   if (IndArray[popcounter-1][4][1]==1) {
      if (Bears[1]<0 && Bears[0]<0) sig++;
      if (Bears[1]>0 && Bears[0]>0) sig++;
   }
   if (IndArray[popcounter-1][5][1]==1) {
      if (Bulls[1]<0 && Bulls[0]<0) sig++;
      if (Bulls[1]>0 && Bulls[0]>0) sig++;
   }
   if (IndArray[popcounter-1][6][1]==1) {
      if (CCI[1]>100 && CCI[0]>100) sig++;
      if (CCI[1]<-100 && CCI[0]<-100) sig++;
      if (CCI[1]>-100 && CCI[1]<100 && CCI[0]>-100 && CCI[0]<100) sig++;
   }
   if (IndArray[popcounter-1][7][1]==1) {
      if (DEM[1]>0.7 && DEM[0]>0.7) sig++;
      if (DEM[1]<0.3 && DEM[0]<0.3) sig++;
      if (DEM[1]>0.3 && DEM[1]<0.7 && DEM[0]>0.3 && DEM[0]<0.7) sig++;
   }
   if (IndArray[popcounter-1][8][1]==1) {
      if (Force[0]>0 && Force[1]>0) sig++;
      if (Force[0]<0 && Force[1]<0) sig++;
   }
   if (IndArray[popcounter-1][9][1]==1) {
      if (MACDM[0]>MACDS[0] && MACDM[1]>MACDS[1] && MACDM[0]>0 && MACDM[1]>0) sig++;
      if (MACDM[0]<MACDS[0] && MACDM[1]<MACDS[1] && MACDM[0]>0 && MACDM[1]>0) sig++;
      if (MACDM[0]>MACDS[0] && MACDM[1]>MACDS[1] && MACDM[0]<0 && MACDM[1]<0) sig++;
      if (MACDM[0]<MACDS[0] && MACDM[1]<MACDS[1] && MACDM[0]<0 && MACDM[1]<0) sig++;
   }
   if (IndArray[popcounter-1][10][1]==1) {
      if (BWMFI[0]>BWMFI[2] && BWMFI[1]>BWMFI[3]) sig++;
      if (BWMFI[0]<BWMFI[2] && BWMFI[1]<BWMFI[3]) sig++;
   }
   if (IndArray[popcounter-1][11][1]==1) {
      if (Momentum[0]>100 && Momentum[1]>100) sig++;
      if (Momentum[0]<100 && Momentum[1]<100) sig++;
   }
   if (IndArray[popcounter-1][12][1]==1) {
      if (MFI[0]>80 && MFI[1]>80) sig++;
      if (MFI[0]<80 && MFI[0]>50 && MFI[1]<80 && MFI[1]>50) sig++;
      if (MFI[0]<50 && MFI[0]>20 && MFI[1]<50 && MFI[1]>20) sig++;
      if (MFI[0]<20 && MFI[1]<20) sig++;
   }
   if (IndArray[popcounter-1][13][1]==1) {
      if (MA1[0]>MA2[0] && MA1[1]>MA2[1]) sig++;
      if (MA1[0]<MA2[0] && MA1[1]<MA2[1]) sig++;
   }
   if (IndArray[popcounter-1][14][1]==1) {
      if (OBV[0]>OBV[2] && OBV[1]>OBV[3]) sig++;
      if (OBV[0]<OBV[2] && OBV[1]<OBV[3]) sig++;
   }
   if (IndArray[popcounter-1][15][1]==1) {
      if (SAR[0]>SAR[2] && SAR[1]>SAR[3]) sig++;
      if (SAR[0]<SAR[2] && SAR[1]<SAR[3]) sig++;
   }
   if (IndArray[popcounter-1][16][1]==1) {
      if (RSI[0]>70 && RSI[1]>70) sig++;
      if (RSI[0]>30 && RSI[0]<70 && RSI[1]>30 && RSI[1]<70) sig++;
      if (RSI[0]<30 && RSI[1]<30) sig++;
   }
   if (IndArray[popcounter-1][17][1]==1) {
      if (STD[0]>STD[2] && STD[1]>STD[3]) sig++;
      if (STD[0]<STD[2] && STD[1]<STD[3]) sig++;
   }
   if (IndArray[popcounter-1][18][1]==1) {
      if (StochM[0]>StochS[0] && StochM[1]>StochS[1]) sig++;
      if (StochM[0]<StochS[0] && StochM[1]<StochS[1]) sig++;
   }
   if (IndArray[popcounter-1][19][1]==1) {
      if (Vol[0]>Vol[2] && Vol[1]>Vol[3]) sig++;
      if (Vol[0]<Vol[2] && Vol[1]<Vol[3]) sig++;
   }
if (sig==sigcheck) return(true);
return(false);
}

void TextSave(string filename, string savetext) {
   int ho=FileOpen(filename , FILE_CSV | FILE_READ | FILE_WRITE);  
       if(ho>0)
        {
        FileSeek (ho, 0, SEEK_END );
        FileWrite(ho,savetext);
        FileClose(ho);                         
        }
}

void VirtualOrderSend(int system, int type, double openprice, double stoploss, double takeprofit) {
    VirtTicket[system] = 1;
    VirtOrderType[system] = type;
    VirtOpenPrice[system] = openprice;
    VirtStopLoss[system] = stoploss;
    VirtTakeProfit[system] = takeprofit;
  }

double PF(int count, int system1) {
   int TotalOrd, TekOrd; 
   int counter=0;
   double Profit=0, Loss=0;    
   if (ArrayRange(VirtClosedOrders,0)==0) return(0);
   TotalOrd = ArrayRange(VirtClosedOrders,0);
   for(TekOrd = TotalOrd-1; TekOrd >= 0; TekOrd--) {
         if (VirtClosedOrders[TekOrd][4][system1]==0) continue;
         if (VirtClosedOrders[TekOrd][4][system1]>0) {
            if (VirtClosedOrders[TekOrd][5][system1]>0) Profit=Profit+VirtClosedOrders[TekOrd][5][system1];
            if (VirtClosedOrders[TekOrd][5][system1]<=0) Loss=Loss-VirtClosedOrders[TekOrd][5][system1];
            counter=counter+1;
         }
         if (counter==count) break;
   }
if (Loss!=0) PFout=Profit/Loss;
if (Loss==0) PFout=1;
return(PFout);
}

void VirtOrderClose(double closeprice, int system) {
   double Equity;
    //----      
    if (VirtClosedOrdersCount[system]==0) Equity=1000;
    if (VirtClosedOrdersCount[system]>0) Equity=VirtClosedOrders[VirtClosedOrdersCount[system]-1][7][system];
//   if (debug) Print("System : ",system,", Equity : ",Equity," , Count : ",VirtClosedOrdersCount[system]);
    if (ArrayRange(VirtClosedOrders,0)<(VirtClosedOrdersCount[system] + 1)) ArrayResize(VirtClosedOrders, VirtClosedOrdersCount[system] + 1);
    if (closeprice<VirtOpenPrice[system] && VirtOrderType[system]==OP_BUY) VirtOrderProfit[system]=(-(VirtOpenPrice[system]-closeprice))/0.0001;
    if (closeprice>VirtOpenPrice[system] && VirtOrderType[system]==OP_BUY) VirtOrderProfit[system]=(closeprice-VirtOpenPrice[system])/0.0001;
    if (closeprice<VirtOpenPrice[system] && VirtOrderType[system]==OP_SELL) VirtOrderProfit[system]=(VirtOpenPrice[system]-closeprice)/0.0001;
    if (closeprice>VirtOpenPrice[system] && VirtOrderType[system]==OP_SELL) VirtOrderProfit[system]=(-(closeprice-VirtOpenPrice[system]))/0.0001;
    VirtClosedOrders[VirtClosedOrdersCount[system]][0][system] = VirtOrderType[system];
    VirtClosedOrders[VirtClosedOrdersCount[system]][1][system] = VirtOpenPrice[system];
    VirtClosedOrders[VirtClosedOrdersCount[system]][2][system] = VirtStopLoss[system];
    VirtClosedOrders[VirtClosedOrdersCount[system]][3][system] = VirtTakeProfit[system];
    VirtClosedOrders[VirtClosedOrdersCount[system]][4][system] = closeprice;
    VirtClosedOrders[VirtClosedOrdersCount[system]][5][system] = VirtOrderProfit[system];
    VirtClosedOrders[VirtClosedOrdersCount[system]][6][system] = PF(PFCount, system);
    VirtClosedOrders[VirtClosedOrdersCount[system]][7][system] = Equity + VirtClosedOrders[VirtClosedOrdersCount[system]][5][system];
  
    VirtClosedOrdersCount[system]++;
 
    //----  
    VirtTicket[system] = 0;
    VirtOrderType[system] = 0;
    VirtOpenPrice[system] = 0.0;
    VirtStopLoss[system] = 0.0;
    VirtTakeProfit[system] = 0.0;
}

void ManageVirtual(int dS, int shiftbar, double TP, double SL, int sys, int shortlong) {
   if (TP==0) TP=10000;
   int spr=MarketInfo(Symbol(),MODE_SPREAD);
   double dA=iClose(Symbol(),0,shiftbar)+spr*Point;
   double dB=iClose(Symbol(),0,shiftbar);
      if (VirtTicket[sys]==0 && dS==1 && shortlong==1) VirtualOrderSend(sys, OP_BUY, dA, dA-SL*0.0001, dA+TP*0.0001);
      if (VirtTicket[sys]==0 && dS==1 && shortlong==0) VirtualOrderSend(sys, OP_SELL, dB, dB+SL*0.0001, dB-TP*0.0001);
      if (VirtTicket[sys]==1 && VirtOrderType[sys]==OP_BUY) {
         if (VirtStopLoss[sys] > 0.0 && NormalizeDouble(VirtStopLoss[sys]-dB, 4) >= 0.0) VirtOrderClose(VirtStopLoss[sys], sys);
         if (VirtTakeProfit[sys] > 0.0 && NormalizeDouble(dB-VirtTakeProfit[sys], 4) >= 0.0) VirtOrderClose(VirtTakeProfit[sys], sys);
      }
      if (VirtTicket[sys]==1 && VirtOrderType[sys] == OP_SELL) {
         if (VirtStopLoss[sys] > 0.0 && NormalizeDouble(dA-VirtStopLoss[sys], 4) >= 0.0) VirtOrderClose(VirtStopLoss[sys], sys);
         if (VirtTakeProfit[sys] > 0.0 && NormalizeDouble(VirtTakeProfit[sys]-dA, 4) >= 0.0) VirtOrderClose(VirtTakeProfit[sys], sys);
      }
}
int Optimize(int savenum) {
   int dSig, saver, dchecker;
   OptInit();
      if (AmountOfSystems!=range) {Print("ERROR : Array with systems not sized correctly! Amount of systems : ",AmountOfSystems); return(0);}
   Comment("Optimization started. Resizing arrays...");
   for (int patcycle=0;patcycle<tech1;patcycle++) {
      IndValue(PatternDown[patcycle],0);
      saver=0;
      for (int cyclesys=0;cyclesys<AmountOfSystems;cyclesys++) {
         if (saver==0 && cyclesys>0) break;
         for (int cycle=MaxBars;cycle>UseBars;cycle--) {
            IndValue(cycle,1);
            dSig=Signal();
            if (debug && dSig==1 && saver==0) Print("Signal poped");
            if (dSig==1) saver=1;
            if (saver==1) {
               ManageVirtual(dSig, cycle, TakeProfit[cyclesys], StopLoss[cyclesys], cyclesys, 0);
               if (VirtTicket[cyclesys]==1 && cycle==UseBars+1) VirtOrderClose(iClose(Symbol(),0,UseBars+1)+MarketInfo(Symbol(),MODE_SPREAD)*Point, cyclesys);
            }
         }
         if (saver==0) Comment("No signals...Pattern DOWN counting : ",patcycle+" out of "+tech1+". Pass : ",savenum);
         if (saver==1) {
            Comment("Current system : "+cyclesys+", pattern : "+patcycle+" out of "+tech1+". TP : "+TakeProfit[cyclesys]+", SL : "+StopLoss[cyclesys],". Pass : ",savenum);
            dchecker=DATAChecker(cyclesys);
            if (dchecker>SavePatternLimit) DATASaver(patcycle, cyclesys, dchecker, savenum, "short");
         }
      }
      ArrayInitialize(VirtClosedOrders,0);
      ArrayInitialize(VirtClosedOrdersCount,0);
      if (ArrayRange(VirtClosedOrders,0)>5000) {Print("Exceeded the limit of systems! Dropping optimization."); return(0);}
   }
   for (int patcycle1=0;patcycle1<tech2;patcycle1++) {
      IndValue(PatternDown[patcycle1],0);
      saver=0;
      for (int cyclesys3=0;cyclesys3<AmountOfSystems;cyclesys3++) {
         if (saver==0 && cyclesys3>0) break;
         for (int cycle2=MaxBars;cycle2>UseBars;cycle2--) {
            IndValue(cycle2,1);
            dSig=Signal();
            if (debug && dSig==1 && saver==0) Print("Signal poped");
            if (dSig==1) saver=1;
            if (saver==1) {
               ManageVirtual(dSig, cycle2, TakeProfit[cyclesys3], StopLoss[cyclesys3], cyclesys3, 1);
               if (VirtTicket[cyclesys3]==1 && cycle2==UseBars+1) VirtOrderClose(iClose(Symbol(),0,UseBars+1), cyclesys3);
            }
         }
         if (saver==0) Comment("No signals...Pattern UP counting : ",patcycle1+" out of "+tech2+". Pass : ",savenum);
         if (saver==1) {
            Comment("Current system : "+cyclesys3+", pattern : "+patcycle1+" out of "+tech2+". TP : "+TakeProfit[cyclesys3]+", SL : "+StopLoss[cyclesys3],". Pass : ",savenum);
            dchecker=DATAChecker(cyclesys3);
            if (dchecker>SavePatternLimit) DATASaver(patcycle1, cyclesys3, dchecker, savenum, "long");
         }
      }
      ArrayInitialize(VirtClosedOrders,0);
      ArrayInitialize(VirtClosedOrdersCount,0);
      if (ArrayRange(VirtClosedOrders,0)>5000) {Print("Exceeded the limit of systems! Dropping optimization."); return(0);}
   }
return(0);
}

int DATAChecker(int systemno) {
   double dPF, dProfit, dMO, dSO, MO, MO1, SO, SO1;
   int MOCounter, SOCounter, cret=0;
      dPF=PF(VirtClosedOrdersCount[systemno], systemno);
      dProfit=VirtClosedOrders[VirtClosedOrdersCount[systemno]-1][7][systemno]-1000;
      for (int kc1=0;kc1<VirtClosedOrdersCount[systemno];kc1++) if (VirtClosedOrders[kc1][1][systemno]>0) {
         MO1+=VirtClosedOrders[kc1][5][systemno]; 
         MOCounter++;
      }
      if (MOCounter!=0) MO=MO1/MOCounter; else MO=0;
      for (int kc2=0;kc2<VirtClosedOrdersCount[systemno];kc2++) if (VirtClosedOrders[kc2][1][systemno]>0) {
         SO1+=MathPow(VirtClosedOrders[kc2][5][systemno]-MO,2); 
         SOCounter++;
      }
      if (SOCounter-1!=0) SO=MathSqrt(SO1/(SOCounter-1)); else SO=0;
      dMO=MO;
      if (SO!=0) dSO=MO/SO; else dSO=0;
if (dPF>1.5) cret++;
if (dProfit>(1500.0/518400.0)*MaxBars*Period()) cret++;
if (dMO>20) cret++;
if (dSO>0.2) cret++;
return(cret);
}
string IndSaver() {
   string stret;
   if (IndArray[popcounter-1][0][1]==1) stret=stret+"AO : "+AO[0]+"; ";
   if (IndArray[popcounter-1][1][1]==1) stret=stret+"AD 0: "+AD[0]+" 1 : "+AD[2]+"; ";
   if (IndArray[popcounter-1][2][1]==1) stret=stret+"ADX "+DoubleToStr(IndArray[popcounter-1][2][2],0)+" + : "+ADXDIplus[0]+" - : "+ADXDIminus[0]+" main : "+ADX[0]+"; ";
   if (IndArray[popcounter-1][3][1]==1) stret=stret+"ATR "+DoubleToStr(IndArray[popcounter-1][3][2],0)+" 0 : "+ATR[0]+" 2 : "+ATR[2]+"; ";
   if (IndArray[popcounter-1][4][1]==1) stret=stret+"Bears "+DoubleToStr(IndArray[popcounter-1][4][2],0)+" : "+Bears[0]+"; ";
   if (IndArray[popcounter-1][5][1]==1) stret=stret+"Bulls "+DoubleToStr(IndArray[popcounter-1][5][2],0)+" : "+Bulls[0]+"; ";
   if (IndArray[popcounter-1][6][1]==1) stret=stret+"CCI "+DoubleToStr(IndArray[popcounter-1][2][6],0)+" : "+CCI[0]+"; ";
   if (IndArray[popcounter-1][7][1]==1) stret=stret+"Dem "+DoubleToStr(IndArray[popcounter-1][2][7],0)+" : "+DEM[0]+"; ";
   if (IndArray[popcounter-1][8][1]==1) stret=stret+"Force "+DoubleToStr(IndArray[popcounter-1][8][2],0)+" : "+Force[0]+"; ";
   if (IndArray[popcounter-1][9][1]==1) stret=stret+"MACD "+DoubleToStr(IndArray[popcounter-1][9][2],0)+"_"+DoubleToStr(IndArray[popcounter-1][9][3],0)+"_"+DoubleToStr(IndArray[popcounter-1][9][4],0)+" Main : "+MACDM[0]+" , Signal : "+MACDS[0]+"; ";
   if (IndArray[popcounter-1][10][1]==1) stret=stret+"BWMFI 0 : "+BWMFI[0]+" 1 : "+BWMFI[2]+"; ";
   if (IndArray[popcounter-1][11][1]==1) stret=stret+"Mom "+DoubleToStr(IndArray[popcounter-1][11][2],0)+" : "+Momentum[0]+"; ";
   if (IndArray[popcounter-1][12][1]==1) stret=stret+"MFI "+DoubleToStr(IndArray[popcounter-1][12][2],0)+" : "+MFI[0]+"; ";
   if (IndArray[popcounter-1][13][1]==1) stret=stret+"MA "+DoubleToStr(IndArray[popcounter-1][13][2],0)+"_"+DoubleToStr(IndArray[popcounter-1][13][3],0)+" MA1: "+MA1[0]+" MA2: "+MA2[0]+"; ";
   if (IndArray[popcounter-1][14][1]==1) stret=stret+"OBV 0 : "+OBV[0]+" 1: "+OBV[2]+"; ";
   if (IndArray[popcounter-1][15][1]==1) stret=stret+"SAR "+DoubleToStr(IndArray[popcounter-1][15][2],2)+"_"+DoubleToStr(IndArray[popcounter-1][15][3],2)+" 0: "+SAR[0]+" 1: "+SAR[2]+"; ";
   if (IndArray[popcounter-1][16][1]==1) stret=stret+"RSI "+DoubleToStr(IndArray[popcounter-1][16][2],0)+" : "+RSI[0]+"; ";
   if (IndArray[popcounter-1][17][1]==1) stret=stret+"STD "+DoubleToStr(IndArray[popcounter-1][17][2],0)+"_"+DoubleToStr(IndArray[popcounter-1][17][3],0)+" 0: "+STD[0]+" 1: "+STD[2]+"; ";
   if (IndArray[popcounter-1][18][1]==1) stret=stret+"Stoch "+DoubleToStr(IndArray[popcounter-1][18][2],0)+"_"+DoubleToStr(IndArray[popcounter-1][18][3],0)+"_"+DoubleToStr(IndArray[popcounter-1][18][4],0)+" Main : "+StochM[0]+" Signal : "+StochS[0]+"; ";
   if (IndArray[popcounter-1][19][1]==1) stret=stret+"Vol 0: "+Vol[0]+" 1: "+Vol[2];
return(stret);
}

int loader(string filename) {
   int ho=FileOpen(filename , FILE_CSV | FILE_READ);  
       if(ho>0) FileClose(ho);                         
return(ho);
}

void DATASaver(int patcycle1, int cyclesys1, int echecker, int savior, string dir) {
   double DD, DrawDown, Amount=0, MO, MO1, SO, SO1, A, Zacc, PFS;
   int MOCounter, SOCounter, ZPlus, ZMinus, P, ZTotal, ZR, TPS, SLS, OrderS, ProfS;
   string Plus="";
   if (loader(echecker+"_"+patcycle1+"_"+savior+"_"+dir+".csv")<1) {
      TextSave(echecker+"_"+patcycle1+"_"+savior+"_"+dir+".csv",IndSaver());
      TextSave(echecker+"_"+patcycle1+"_"+savior+"_"+dir+".csv","TP;SL;PF;Profit;DrawDown;Orders;MO;SO;MO/SO;Z account");
      }
      TPS=TakeProfit[cyclesys1];
      SLS=StopLoss[cyclesys1];
      PFS=PF(VirtClosedOrdersCount[cyclesys1], cyclesys1);
      ProfS=VirtClosedOrders[VirtClosedOrdersCount[cyclesys1]-1][7][cyclesys1]-1000; //Profit
      DD=1001;
      for (int cyclesys2=0;cyclesys2<VirtClosedOrdersCount[cyclesys1];cyclesys2++) if (DD>VirtClosedOrders[cyclesys2][7][cyclesys1]) DD=VirtClosedOrders[cyclesys2][7][cyclesys1];
      if (DD>=1000) DrawDown=0;
      if (DD<=0) DrawDown=100;
      if (DD>0 && DD<1000) DrawDown=(1000-DD)/10;
      OrderS=VirtClosedOrdersCount[cyclesys1];
      MO=0; MO1=0; SO=0; MOCounter=0; SO1=0; SOCounter=0; Plus=""; ZTotal=0; ZPlus=0; ZMinus=0; ZR=0; P=0; Zacc=0;
      for (int kc1=0;kc1<VirtClosedOrdersCount[cyclesys1];kc1++) if (VirtClosedOrders[kc1][1][cyclesys1]>0) {
         MO1+=VirtClosedOrders[kc1][5][cyclesys1]; 
         MOCounter++;
         //Z-account counter begin
         ZTotal++;
         if (VirtClosedOrders[kc1][5][cyclesys1]>0) ZPlus++;
         if (VirtClosedOrders[kc1][5][cyclesys1]<0) ZMinus++;
         if ((VirtClosedOrders[kc1][5][cyclesys1]>0 || VirtClosedOrders[kc1][5][cyclesys1]<=0) && kc1==0) ZR++;
         if (VirtClosedOrders[kc1][5][cyclesys1]>0 && VirtClosedOrders[kc1-1][5][cyclesys1]<=0 && kc1>0) ZR++;
         if (VirtClosedOrders[kc1][5][cyclesys1]<=0 && VirtClosedOrders[kc1-1][5][cyclesys1]>0 && kc1>0) ZR++;
         //Z-account counter 
      }
      if (MOCounter!=0) MO=MO1/MOCounter; else MO=0;
      for (int kc2=0;kc2<VirtClosedOrdersCount[cyclesys1];kc2++) if (VirtClosedOrders[kc2][1][cyclesys1]>0) {
         SO1+=MathPow(VirtClosedOrders[kc2][5][cyclesys1]-MO,2); 
         SOCounter++;
      }
      if (SOCounter-1!=0) SO=MathSqrt(SO1/(SOCounter-1)); else SO=0;
      P=2*ZPlus*ZMinus;
      if (P*(P-ZTotal)!=0 && (ZTotal-1)!=0) Zacc=MathPow((ZTotal*(ZR-0.5)-P)/((P*(P-ZTotal))/(ZTotal-1)),0.5); else Zacc=0;
      if (SO!=0) A=MO/SO; else A=0;
   TextSave(echecker+"_"+patcycle1+"_"+savior+"_"+dir+".csv",TPS+";"+SLS+";"+DoubleToStr(PFS,2)+";"+ProfS+";"+DoubleToStr(DrawDown,0)+";"+OrderS+";"+DoubleToStr(MO,2)+";"+DoubleToStr(SO,2)+";"+DoubleToStr(A,2)+";"+DoubleToStr(Zacc,2));
}

int start() {
   for (int k3=0;k3<MathPow(2,20);k3++) {
      CreatePopulation();
      Optimize(k3);
         if (AmountOfSystems!=range) {Print("ERROR : Array with systems not sized correctly! Amount of systems : ",AmountOfSystems); return(0);}
      
   }
return(0);
}